Index: /branches/HTM-6.2-dev0/source/Lib/TLibDecoder/TDecCAVLC.cpp
===================================================================
--- /branches/HTM-6.2-dev0/source/Lib/TLibDecoder/TDecCAVLC.cpp	(revision 426)
+++ /branches/HTM-6.2-dev0/source/Lib/TLibDecoder/TDecCAVLC.cpp	(revision 427)
@@ -265,4 +265,5 @@
     xParseDblParam( aps );    
   }
+#if !LGE_SAO_MIGRATION_D0091
   READ_FLAG(uiCode, "aps_sao_interleaving_flag");      aps->setSaoInterleavingFlag( (uiCode==1)?true:false );
   if(!aps->getSaoInterleavingFlag())
@@ -275,4 +276,5 @@
   }
   }
+#endif
   READ_FLAG(uiCode, "aps_adaptive_loop_filter_flag");      aps->setAlfEnabled( (uiCode==1)?true:false );
   if(aps->getAlfEnabled())
@@ -307,4 +309,5 @@
   }
 }
+#if !LGE_SAO_MIGRATION_D0091
 /** parse SAO parameters
  * \param pSaoParam
@@ -532,5 +535,5 @@
   }
 }
-
+#endif
 
 Void TDecCavlc::xParseAlfParam(AlfParamSet* pAlfParamSet, Bool bSentInAPS, Int firstLCUAddr, Bool acrossSlice, Int numLCUInWidth, Int numLCUInHeight)
@@ -1623,4 +1626,16 @@
 
       }
+
+#if MTK_D0156
+
+      pcSPS->setUseVSPCompensation( false );
+      pcSPS->setUseDVPRefine( false );
+
+      //Comments: Currently, BVSP and DoNBDV are not used for depth coding
+#if MERL_VSP_COMPENSATION_C0152
+      READ_FLAG( uiCode, "view_synthesis_pred_flag" );pcSPS->setUseVSPCompensation( uiCode ? true : false );
+#endif
+      READ_FLAG( uiCode, "dv_refine_flag" );          pcSPS->setUseDVPRefine( uiCode ? true : false );
+#endif
     }
     READ_FLAG( uiCode, "sps_extension2_flag");
@@ -1686,4 +1701,11 @@
     }
     rpcSlice->setApplyIC(uiCodeTmp);
+#if SHARP_ILLUCOMP_PARSE_D0060
+    if (rpcSlice->getApplyIC())
+    {
+      READ_FLAG (uiCodeTmp, "ic_skip_mergeidx0");
+      rpcSlice->setIcSkipParseFlag(uiCodeTmp);
+    }
+#endif
   }
 #endif
@@ -1868,4 +1890,8 @@
       if (sps->getUseSAO())
       {
+#if LGE_SAO_MIGRATION_D0091
+        READ_FLAG(uiCode, "slice_sao_luma_flag");  rpcSlice->setSaoEnabledFlag((Bool)uiCode);
+        READ_FLAG(uiCode, "slice_sao_chroma_flag");  rpcSlice->setSaoEnabledFlagChroma((Bool)uiCode);
+#else
         READ_FLAG(uiCode, "slice_sao_interleaving_flag");        rpcSlice->setSaoInterleavingFlag(uiCode);
         READ_FLAG(uiCode, "slice_sample_adaptive_offset_flag");  rpcSlice->setSaoEnabledFlag((Bool)uiCode);
@@ -1880,4 +1906,5 @@
           rpcSlice->setSaoEnabledFlagCr(0);
         }
+#endif
       }
       READ_UVLC (    uiCode, "aps_id" );  rpcSlice->setAPSId(uiCode);
Index: /branches/HTM-6.2-dev0/source/Lib/TLibDecoder/TDecCAVLC.h
===================================================================
--- /branches/HTM-6.2-dev0/source/Lib/TLibDecoder/TDecCAVLC.h	(revision 426)
+++ /branches/HTM-6.2-dev0/source/Lib/TLibDecoder/TDecCAVLC.h	(revision 427)
@@ -180,7 +180,9 @@
 protected:
   Void  xParseDblParam       ( TComAPS* aps );
+#if !LGE_SAO_MIGRATION_D0091
   Void  xParseSaoParam       ( SAOParam* pSaoParam );
   Void  xParseSaoOffset      (SaoLcuParam* saoLcuParam);
   Void  xParseSaoUnit        (Int rx, Int ry, Int compIdx, SAOParam* saoParam, Bool& repeatedRow );
+#endif
   Void  xParseAlfParam(AlfParamSet* pAlfParamSet, Bool bSentInAPS = true, Int firstLCUAddr = 0, Bool acrossSlice = true, Int numLCUInWidth= -1, Int numLCUInHeight= -1);
   Void  parseAlfParamSet(AlfParamSet* pAlfParamSet, Int firstLCUAddr, Bool alfAcrossSlice);
Index: /branches/HTM-6.2-dev0/source/Lib/TLibDecoder/TDecCu.cpp
===================================================================
--- /branches/HTM-6.2-dev0/source/Lib/TLibDecoder/TDecCu.cpp	(revision 426)
+++ /branches/HTM-6.2-dev0/source/Lib/TLibDecoder/TDecCu.cpp	(revision 427)
@@ -415,5 +415,13 @@
     UInt uiMergeIndex = pcCU->getMergeIndex(uiAbsPartIdx);
 #if MERL_VSP_C0152
+#if LGE_VSP_INHERIT_D0092
+    Int iVSPIndexTrue[MRG_MAX_NUM_CANDS_MEM];
+    for (Int i=0; i<MRG_MAX_NUM_CANDS_MEM; i++)
+    {
+        iVSPIndexTrue[i] = 0;
+    }
+#else
     Int iVSPIndexTrue[3] = {-1, -1, -1};
+#endif
 #if MERL_VSP_NBDV_RefVId_Fix_D0166
     Int iVSPDirTrue[3]   = {-1, -1, -1};
@@ -422,6 +430,19 @@
     m_ppcCU[uiDepth]->getInterMergeCandidates( 0, 0, uiDepth, cMvFieldNeighbours, uhInterDirNeighbours, numValidMergeCand, iVSPIndexTrue, uiMergeIndex );
 #endif
+#if MTK_D0156
+    if( !pcCU->getSlice()->getSPS()->getUseVSPCompensation() )
+    {
+        pcCU->setVSPIndexSubParts( 0, uiAbsPartIdx, 0, uiDepth ); 
+    }
+    else
+#endif
     {
       Int iVSPIdx = 0;
+#if LGE_VSP_INHERIT_D0092
+      if (iVSPIndexTrue[uiMergeIndex] == 1)
+      {
+          iVSPIdx = 1;
+      }
+#else
       Int numVspIdx;
       numVspIdx = 3;
@@ -434,7 +455,15 @@
           }
       }
+#endif
       pcCU->setVSPIndexSubParts( iVSPIdx, uiAbsPartIdx, 0, uiDepth );  // Initialize
 #if MERL_VSP_NBDV_RefVId_Fix_D0166
       pcCU->setVSPDirSubParts( iVSPDirTrue[iVSPIdx-1], uiAbsPartIdx, 0, uiDepth );
+#endif
+#if QC_BVSP_CleanUP_D0191 && !LGE_VSP_INHERIT_D0092
+      if(iVSPIdx != 0)
+      {
+        Int iIVCIdx = pcCU->getSlice()->getRefPic(REF_PIC_LIST_0, 0)->getPOC()==pcCU->getSlice()->getPOC() ? 0: pcCU->getSlice()->getNewRefIdx(REF_PIC_LIST_0);
+       cMvFieldNeighbours[ 2*uiMergeIndex].setRefIdx(iIVCIdx);
+      }
 #endif
     }
Index: /branches/HTM-6.2-dev0/source/Lib/TLibDecoder/TDecEntropy.cpp
===================================================================
--- /branches/HTM-6.2-dev0/source/Lib/TLibDecoder/TDecEntropy.cpp	(revision 426)
+++ /branches/HTM-6.2-dev0/source/Lib/TLibDecoder/TDecEntropy.cpp	(revision 427)
@@ -320,5 +320,13 @@
       UInt uiMergeIndex = pcCU->getMergeIndex(uiSubPartIdx);
 #if MERL_VSP_C0152
+#if LGE_VSP_INHERIT_D0092
+      Int iVSPIndexTrue[MRG_MAX_NUM_CANDS_MEM];
+      for (Int i=0; i<MRG_MAX_NUM_CANDS_MEM; i++)
+      {
+          iVSPIndexTrue[i] = 0;
+      }
+#else
       Int iVSPIndexTrue[3] = {-1, -1, -1};
+#endif
 #if MERL_VSP_NBDV_RefVId_Fix_D0166
       Int iVSPDirTrue[3]   = {-1, -1, -1};
@@ -344,6 +352,19 @@
       else // MPI not used
 #endif
+#if MTK_D0156
+          if( !pcCU->getSlice()->getSPS()->getUseVSPCompensation() )
+          {
+              pcCU->setVSPIndexSubParts( 0, uiSubPartIdx, uiPartIdx, uiDepth ); 
+          }
+          else
+#endif
       {
         Int iVSPIdx = 0;
+#if LGE_VSP_INHERIT_D0092
+        if (iVSPIndexTrue[uiMergeIndex] == 1)
+        {
+            iVSPIdx = 1;
+        }
+#else
         Int numVspIdx;
         numVspIdx = 3;
@@ -356,7 +377,15 @@
             }
         }
+#endif
         pcCU->setVSPIndexSubParts( iVSPIdx, uiSubPartIdx, uiPartIdx, uiDepth );               // Initialize
 #if MERL_VSP_NBDV_RefVId_Fix_D0166
         pcCU->setVSPDirSubParts( iVSPDirTrue[iVSPIdx-1], uiSubPartIdx, uiPartIdx, uiDepth );  // Initialize
+#endif
+#if QC_BVSP_CleanUP_D0191 && !LGE_VSP_INHERIT_D0092
+       if(iVSPIdx != 0) 
+       {
+         Int iIVCIdx = pcCU->getSlice()->getRefPic(REF_PIC_LIST_0, 0)->getPOC()==pcCU->getSlice()->getPOC() ? 0: pcCU->getSlice()->getNewRefIdx(REF_PIC_LIST_0);
+         cMvFieldNeighbours[ 2*uiMergeIndex].setRefIdx(iIVCIdx);
+       }
 #endif
       }
@@ -509,5 +538,9 @@
   {
 #if H3D_IVMP
+#if SEC_TWO_CANDIDATES_FOR_AMVP_D0122
+    const Int iNumAMVPCands = AMVP_MAX_NUM_CANDS;
+#else
     const Int iNumAMVPCands = AMVP_MAX_NUM_CANDS + ( pcSubCU->getSlice()->getSPS()->getMultiviewMvPredMode() ? 1 : 0 );
+#endif
     m_pcEntropyDecoderIf->parseMVPIdx( iMVPIdx, iNumAMVPCands );
 #else
Index: /branches/HTM-6.2-dev0/source/Lib/TLibDecoder/TDecEntropy.h
===================================================================
--- /branches/HTM-6.2-dev0/source/Lib/TLibDecoder/TDecEntropy.h	(revision 426)
+++ /branches/HTM-6.2-dev0/source/Lib/TLibDecoder/TDecEntropy.h	(revision 427)
@@ -231,7 +231,9 @@
   Void setSliceGranularity (Int iSliceGranularity) {m_pcEntropyDecoderIf->setSliceGranularity(iSliceGranularity);}
 
+#if !LGE_SAO_MIGRATION_D0091
   Void decodeSaoParam         (SAOParam* saoParam);
   void decodeSaoLcu(Int rx, Int ry, Int compIdx, SAOParam* saoParam, Bool &repeatedRow );
   Void decodeSaoOneLcu(SaoLcuParam* saoLcuParam);
+#endif
 
   Void decodeFlush() { m_pcEntropyDecoderIf->decodeFlush(); }
Index: /branches/HTM-6.2-dev0/source/Lib/TLibDecoder/TDecGop.cpp
===================================================================
--- /branches/HTM-6.2-dev0/source/Lib/TLibDecoder/TDecGop.cpp	(revision 426)
+++ /branches/HTM-6.2-dev0/source/Lib/TLibDecoder/TDecGop.cpp	(revision 427)
@@ -372,4 +372,17 @@
     if( pcSlice->getSPS()->getUseSAO() )
     {
+#if LGE_SAO_MIGRATION_D0091
+        if(pcSlice->getSaoEnabledFlag()||pcSlice->getSaoEnabledFlagChroma())
+        {
+            SAOParam *saoParam = pcSlice->getAPS()->getSaoParam();
+            saoParam->bSaoFlag[0] = pcSlice->getSaoEnabledFlag();
+            saoParam->bSaoFlag[1] = pcSlice->getSaoEnabledFlagChroma();
+            m_pcSAO->setSaoLcuBasedOptimization(1);
+            m_pcSAO->createPicSaoInfo(rpcPic, m_uiILSliceCount);
+            m_pcSAO->SAOProcess(rpcPic, saoParam);
+            m_pcSAO->PCMLFDisableProcess(rpcPic);
+            m_pcSAO->destroyPicSaoInfo();
+        }
+#else
       if(pcSlice->getSaoEnabledFlag())
       {
@@ -388,4 +401,5 @@
         m_pcSAO->destroyPicSaoInfo();
       }
+#endif
     }
 
Index: /branches/HTM-6.2-dev0/source/Lib/TLibDecoder/TDecSbac.cpp
===================================================================
--- /branches/HTM-6.2-dev0/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 426)
+++ /branches/HTM-6.2-dev0/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 427)
@@ -91,4 +91,8 @@
 , m_cALFSvlcSCModel           ( 1,             1,               NUM_ALF_SVLC_CTX              , m_contextModels + m_numContextModels, m_numContextModels)
 , m_cCUAMPSCModel             ( 1,             1,               NUM_CU_AMP_CTX                , m_contextModels + m_numContextModels, m_numContextModels)
+#if LGE_SAO_MIGRATION_D0091
+, m_cSaoMergeSCModel          ( 1,             1,               NUM_SAO_MERGE_FLAG_CTX        , m_contextModels + m_numContextModels, m_numContextModels)
+, m_cSaoTypeIdxSCModel        ( 1,             1,               NUM_SAO_TYPE_IDX_CTX          , m_contextModels + m_numContextModels, m_numContextModels)
+#else
 , m_cSaoFlagSCModel           ( 1,             1,               NUM_SAO_FLAG_CTX              , m_contextModels + m_numContextModels, m_numContextModels)
 , m_cSaoUvlcSCModel           ( 1,             1,               NUM_SAO_UVLC_CTX              , m_contextModels + m_numContextModels, m_numContextModels)
@@ -97,4 +101,5 @@
 , m_cSaoMergeUpSCModel        ( 1,             1,               NUM_SAO_MERGE_UP_FLAG_CTX     , m_contextModels + m_numContextModels, m_numContextModels)
 , m_cSaoTypeIdxSCModel        ( 1,             1,               NUM_SAO_TYPE_IDX_CTX          , m_contextModels + m_numContextModels, m_numContextModels)
+#endif
 #if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX
 , m_cDmmFlagSCModel           ( 1,             1,               NUM_DMM_FLAG_CTX              , m_contextModels + m_numContextModels, m_numContextModels)
@@ -190,4 +195,8 @@
   m_cALFUvlcSCModel.initBuffer           ( sliceType, qp, (UChar*)INIT_ALF_UVLC );
   m_cALFSvlcSCModel.initBuffer           ( sliceType, qp, (UChar*)INIT_ALF_SVLC );
+#if LGE_SAO_MIGRATION_D0091
+  m_cSaoMergeSCModel.initBuffer          ( sliceType, qp, (UChar*)INIT_SAO_MERGE_FLAG );
+  m_cSaoTypeIdxSCModel.initBuffer        ( sliceType, qp, (UChar*)INIT_SAO_TYPE_IDX );
+#else
   m_cSaoFlagSCModel.initBuffer           ( sliceType, qp, (UChar*)INIT_SAO_FLAG );
   m_cSaoUvlcSCModel.initBuffer           ( sliceType, qp, (UChar*)INIT_SAO_UVLC );
@@ -196,4 +205,5 @@
   m_cSaoMergeUpSCModel.initBuffer        ( sliceType, qp, (UChar*)INIT_SAO_MERGE_UP_FLAG );
   m_cSaoTypeIdxSCModel.initBuffer        ( sliceType, qp, (UChar*)INIT_SAO_TYPE_IDX );
+#endif
 
   m_cCUTransSubdivFlagSCModel.initBuffer ( sliceType, qp, (UChar*)INIT_TRANS_SUBDIV_FLAG );
@@ -280,4 +290,8 @@
   m_cALFUvlcSCModel.initBuffer           ( eSliceType, iQp, (UChar*)INIT_ALF_UVLC );
   m_cALFSvlcSCModel.initBuffer           ( eSliceType, iQp, (UChar*)INIT_ALF_SVLC );
+#if LGE_SAO_MIGRATION_D0091
+  m_cSaoMergeSCModel.initBuffer          ( eSliceType, iQp, (UChar*)INIT_SAO_MERGE_FLAG );
+  m_cSaoTypeIdxSCModel.initBuffer        ( eSliceType, iQp, (UChar*)INIT_SAO_TYPE_IDX );
+#else
   m_cSaoFlagSCModel.initBuffer           ( eSliceType, iQp, (UChar*)INIT_SAO_FLAG );
   m_cSaoUvlcSCModel.initBuffer           ( eSliceType, iQp, (UChar*)INIT_SAO_UVLC );
@@ -286,4 +300,5 @@
   m_cSaoMergeUpSCModel.initBuffer        ( eSliceType, iQp, (UChar*)INIT_SAO_MERGE_UP_FLAG );
   m_cSaoTypeIdxSCModel.initBuffer        ( eSliceType, iQp, (UChar*)INIT_SAO_TYPE_IDX );
+#endif
   m_cCUTransSubdivFlagSCModel.initBuffer ( eSliceType, iQp, (UChar*)INIT_TRANS_SUBDIV_FLAG );
 #if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX
@@ -1681,5 +1696,250 @@
 }
 
-
+#if LGE_SAO_MIGRATION_D0091
+Void TDecSbac::parseSaoMaxUvlc ( UInt& val, UInt maxSymbol )
+{
+    if (maxSymbol == 0)
+    {
+        val = 0;
+        return;
+    }
+
+    UInt code;
+    Int  i;
+    m_pcTDecBinIf->decodeBinEP( code );
+    if ( code == 0 )
+    {
+        val = 0;
+        return;
+    }
+
+    i=1;
+    while (1)
+    {
+        m_pcTDecBinIf->decodeBinEP( code );
+        if ( code == 0 )
+        {
+            break;
+        }
+        i++;
+        if (i == maxSymbol)
+        {
+            break;
+        }
+    }   
+
+    val = i;
+}
+
+Void TDecSbac::parseSaoUflc (UInt uiLength, UInt&  riVal)
+{
+    m_pcTDecBinIf->decodeBinsEP ( riVal, uiLength );
+}
+
+Void TDecSbac::parseSaoMerge (UInt&  ruiVal)
+{
+    UInt uiCode;
+    m_pcTDecBinIf->decodeBin( uiCode, m_cSaoMergeSCModel.get( 0, 0, 0 ) );
+    ruiVal = (Int)uiCode;
+}
+
+Void TDecSbac::parseSaoTypeIdx (UInt&  ruiVal)
+{
+    UInt uiCode;
+    m_pcTDecBinIf->decodeBin( uiCode, m_cSaoTypeIdxSCModel.get( 0, 0, 0 ) );
+    if (uiCode == 0) 
+    {
+        ruiVal = 0;
+    }
+    else
+    {
+        m_pcTDecBinIf->decodeBinEP( uiCode ); 
+        if (uiCode == 0)
+        {
+            ruiVal = 5;
+        }
+        else
+        {
+            ruiVal = 1;
+        }
+    }
+}
+
+inline Void copySaoOneLcuParam(SaoLcuParam* psDst,  SaoLcuParam* psSrc)
+{
+    Int i;
+    psDst->partIdx = psSrc->partIdx;
+    psDst->typeIdx = psSrc->typeIdx;
+    if (psDst->typeIdx != -1)
+    {
+        psDst->subTypeIdx = psSrc->subTypeIdx ;
+        psDst->length  = psSrc->length;
+        for (i=0;i<psDst->length;i++)
+        {
+            psDst->offset[i] = psSrc->offset[i];
+        }
+    }
+    else
+    {
+        psDst->length  = 0;
+        for (i=0;i<SAO_BO_LEN;i++)
+        {
+            psDst->offset[i] = 0;
+        }
+    }
+}
+
+Void TDecSbac::parseSaoOffset(SaoLcuParam* psSaoLcuParam, UInt compIdx)
+{
+    UInt uiSymbol;
+    static Int iTypeLength[MAX_NUM_SAO_TYPE] =
+    {
+        SAO_EO_LEN,
+        SAO_EO_LEN,
+        SAO_EO_LEN,
+        SAO_EO_LEN,
+        SAO_BO_LEN
+    }; 
+
+    if (compIdx==2)
+    {
+        uiSymbol = (UInt)( psSaoLcuParam->typeIdx + 1);
+    }
+    else
+    {
+        parseSaoTypeIdx(uiSymbol);
+    }
+    psSaoLcuParam->typeIdx = (Int)uiSymbol - 1;
+
+    if (uiSymbol)
+    {
+        psSaoLcuParam->length = iTypeLength[psSaoLcuParam->typeIdx];
+#if FULL_NBIT
+        Int offsetTh = 1 << ( min((Int)(g_uiBitDepth + (g_uiBitDepth-8)-5),5) );
+#else
+        Int offsetTh = 1 << ( min((Int)(g_uiBitDepth + g_uiBitIncrement-5),5) );
+#endif
+
+        if( psSaoLcuParam->typeIdx == SAO_BO )
+        {
+            for(Int i=0; i< psSaoLcuParam->length; i++)
+            {
+                parseSaoMaxUvlc(uiSymbol, offsetTh -1 );
+                psSaoLcuParam->offset[i] = uiSymbol;
+            }   
+            for(Int i=0; i< psSaoLcuParam->length; i++)
+            {
+                if (psSaoLcuParam->offset[i] != 0)
+                {
+                    m_pcTDecBinIf->decodeBinEP ( uiSymbol);
+                    if (uiSymbol)
+                    {
+                        psSaoLcuParam->offset[i] = -psSaoLcuParam->offset[i] ;
+                    }
+                }
+            }
+            parseSaoUflc(5, uiSymbol );
+            psSaoLcuParam->subTypeIdx = uiSymbol;
+        }
+        else if( psSaoLcuParam->typeIdx < 4 )
+        {
+            parseSaoMaxUvlc(uiSymbol, offsetTh -1 ); psSaoLcuParam->offset[0] = uiSymbol;   
+            parseSaoMaxUvlc(uiSymbol, offsetTh -1 ); psSaoLcuParam->offset[1] = uiSymbol;
+            parseSaoMaxUvlc(uiSymbol, offsetTh -1 ); psSaoLcuParam->offset[2] = -(Int)uiSymbol;
+            parseSaoMaxUvlc(uiSymbol, offsetTh -1 ); psSaoLcuParam->offset[3] = -(Int)uiSymbol;
+            if (compIdx != 2)
+            {
+                parseSaoUflc(2, uiSymbol );
+                psSaoLcuParam->subTypeIdx = uiSymbol;
+                psSaoLcuParam->typeIdx += psSaoLcuParam->subTypeIdx;
+            }
+        }
+    }
+    else
+    {
+        psSaoLcuParam->length = 0;
+    }
+}
+
+Void TDecSbac::parseSaoOneLcuInterleaving(Int rx, Int ry, SAOParam* pSaoParam, TComDataCU* pcCU, Int iCUAddrInSlice, Int iCUAddrUpInSlice, Int allowMergeLeft, Int allowMergeUp)
+{
+    Int iAddr = pcCU->getAddr();
+    UInt uiSymbol;
+
+    for (Int iCompIdx=0; iCompIdx<3; iCompIdx++)
+    {
+        pSaoParam->saoLcuParam[iCompIdx][iAddr].mergeUpFlag    = 0;
+        pSaoParam->saoLcuParam[iCompIdx][iAddr].mergeLeftFlag  = 0;
+        pSaoParam->saoLcuParam[iCompIdx][iAddr].subTypeIdx     = 0;
+        pSaoParam->saoLcuParam[iCompIdx][iAddr].typeIdx        =-1;
+        pSaoParam->saoLcuParam[iCompIdx][iAddr].offset[0]      = 0;
+        pSaoParam->saoLcuParam[iCompIdx][iAddr].offset[1]      = 0;
+        pSaoParam->saoLcuParam[iCompIdx][iAddr].offset[2]      = 0;
+        pSaoParam->saoLcuParam[iCompIdx][iAddr].offset[3]      = 0;
+    }
+    if (pSaoParam->bSaoFlag[0] || pSaoParam->bSaoFlag[1] )
+    {
+        if (rx>0 && iCUAddrInSlice!=0 && allowMergeLeft)
+        {
+            parseSaoMerge(uiSymbol); 
+            pSaoParam->saoLcuParam[0][iAddr].mergeLeftFlag = (Bool)uiSymbol;  
+        }
+        if (pSaoParam->saoLcuParam[0][iAddr].mergeLeftFlag==0)
+        {
+            if ((ry > 0) && (iCUAddrUpInSlice>=0) && allowMergeUp)
+            {
+                parseSaoMerge(uiSymbol);
+                pSaoParam->saoLcuParam[0][iAddr].mergeUpFlag = (Bool)uiSymbol;
+            }
+        }
+    }
+
+    for (Int iCompIdx=0; iCompIdx<3; iCompIdx++)
+    {
+        if ((iCompIdx == 0  && pSaoParam->bSaoFlag[0]) || (iCompIdx > 0  && pSaoParam->bSaoFlag[1]) )
+        {
+            if (rx>0 && iCUAddrInSlice!=0 && allowMergeLeft)
+            {
+                pSaoParam->saoLcuParam[iCompIdx][iAddr].mergeLeftFlag = pSaoParam->saoLcuParam[0][iAddr].mergeLeftFlag;
+            }
+            else
+            {
+                pSaoParam->saoLcuParam[iCompIdx][iAddr].mergeLeftFlag = 0;
+            }
+
+            if (pSaoParam->saoLcuParam[iCompIdx][iAddr].mergeLeftFlag==0)
+            {
+                if ((ry > 0) && (iCUAddrUpInSlice>=0) && allowMergeUp)
+                {
+                    pSaoParam->saoLcuParam[iCompIdx][iAddr].mergeUpFlag = pSaoParam->saoLcuParam[0][iAddr].mergeUpFlag;
+                }
+                else
+                {
+                    pSaoParam->saoLcuParam[iCompIdx][iAddr].mergeUpFlag = 0;
+                }
+    
+                if (!pSaoParam->saoLcuParam[iCompIdx][iAddr].mergeUpFlag)
+                {
+                    pSaoParam->saoLcuParam[2][iAddr].typeIdx = pSaoParam->saoLcuParam[1][iAddr].typeIdx;
+                    parseSaoOffset(&(pSaoParam->saoLcuParam[iCompIdx][iAddr]), iCompIdx);
+                }
+                else
+                {
+                    copySaoOneLcuParam(&pSaoParam->saoLcuParam[iCompIdx][iAddr], &pSaoParam->saoLcuParam[iCompIdx][iAddr-pSaoParam->numCuInWidth]);
+                }
+            }
+            else
+            {
+                copySaoOneLcuParam(&pSaoParam->saoLcuParam[iCompIdx][iAddr],  &pSaoParam->saoLcuParam[iCompIdx][iAddr-1]);
+            }
+        }
+        else
+        {
+            pSaoParam->saoLcuParam[iCompIdx][iAddr].typeIdx    = -1;
+            pSaoParam->saoLcuParam[iCompIdx][iAddr].subTypeIdx = 0;
+        }
+    }
+}
+#else
 Void TDecSbac::parseSaoUvlc (UInt& ruiVal)
 {
@@ -1918,5 +2178,5 @@
   }
 }
-
+#endif
 /**
  - Initialize our contexts from the nominated source.
Index: /branches/HTM-6.2-dev0/source/Lib/TLibDecoder/TDecSbac.h
===================================================================
--- /branches/HTM-6.2-dev0/source/Lib/TLibDecoder/TDecSbac.h	(revision 426)
+++ /branches/HTM-6.2-dev0/source/Lib/TLibDecoder/TDecSbac.h	(revision 427)
@@ -110,4 +110,12 @@
 #endif
   
+#if LGE_SAO_MIGRATION_D0091
+  Void  parseSaoMaxUvlc           ( UInt& val, UInt maxSymbol );
+  Void  parseSaoMerge             ( UInt&  ruiVal   );
+  Void  parseSaoTypeIdx           ( UInt&  ruiVal  );
+  Void  parseSaoUflc              ( UInt uiLength, UInt& ruiVal     );
+  Void  parseSaoOneLcuInterleaving(Int rx, Int ry, SAOParam* pSaoParam, TComDataCU* pcCU, Int iCUAddrInSlice, Int iCUAddrUpInSlice, Int allowMergeLeft, Int allowMergeUp);
+  Void  parseSaoOffset            (SaoLcuParam* psSaoLcuParam, UInt compIdx);
+#else
   Void  parseSaoUvlc              ( UInt& ruiVal           );
   Void  parseSaoSvlc              ( Int&  riVal            );
@@ -118,4 +126,5 @@
   Void  parseSaoOneLcuInterleaving(Int rx, Int ry, SAOParam* pSaoParam, TComDataCU* pcCU, Int iCUAddrInSlice, Int iCUAddrUpInSlice, Bool bLFCrossSliceBoundaryFlag);
   Void  parseSaoOffset            (SaoLcuParam* psSaoLcuParam);
+#endif
   
 #if RWTH_SDC_DLT_B0036
@@ -251,4 +260,8 @@
   ContextModel3DBuffer m_cALFSvlcSCModel;
   ContextModel3DBuffer m_cCUAMPSCModel;
+#if LGE_SAO_MIGRATION_D0091
+  ContextModel3DBuffer m_cSaoMergeSCModel;
+  ContextModel3DBuffer m_cSaoTypeIdxSCModel;
+#else
   ContextModel3DBuffer m_cSaoFlagSCModel;
   ContextModel3DBuffer m_cSaoUvlcSCModel;
@@ -257,4 +270,5 @@
   ContextModel3DBuffer m_cSaoMergeUpSCModel;
   ContextModel3DBuffer m_cSaoTypeIdxSCModel;
+#endif
 
 #if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX
Index: /branches/HTM-6.2-dev0/source/Lib/TLibDecoder/TDecSlice.cpp
===================================================================
--- /branches/HTM-6.2-dev0/source/Lib/TLibDecoder/TDecSlice.cpp	(revision 426)
+++ /branches/HTM-6.2-dev0/source/Lib/TLibDecoder/TDecSlice.cpp	(revision 427)
@@ -286,4 +286,37 @@
     g_bJustDoIt = g_bEncDecTraceEnable;
 #endif
+#if LGE_SAO_MIGRATION_D0091
+    if ( pcSlice->getSPS()->getUseSAO() && (pcSlice->getSaoEnabledFlag()||pcSlice->getSaoEnabledFlagChroma()) )
+    {
+        SAOParam *saoParam =  pcSlice->getAPS()->getSaoParam();
+        saoParam->bSaoFlag[0] = pcSlice->getSaoEnabledFlag();
+    if (iCUAddr == iStartCUAddr)
+    {
+        saoParam->bSaoFlag[1] = pcSlice->getSaoEnabledFlagChroma();
+    }
+    Int numCuInWidth     = saoParam->numCuInWidth;
+    Int cuAddrInSlice = iCUAddr - rpcPic->getPicSym()->getCUOrderMap(pcSlice->getSliceCurStartCUAddr()/rpcPic->getNumPartInCU());
+    Int cuAddrUpInSlice  = cuAddrInSlice - numCuInWidth;
+    Int rx = iCUAddr % numCuInWidth;
+    Int ry = iCUAddr / numCuInWidth;
+    Int allowMergeLeft = 1;
+    Int allowMergeUp   = 1;
+    if (rx!=0)
+    {
+        if (rpcPic->getPicSym()->getTileIdxMap(iCUAddr-1) != rpcPic->getPicSym()->getTileIdxMap(iCUAddr))
+        {
+            allowMergeLeft = 0;
+        }
+    }
+    if (ry!=0)
+    {
+        if (rpcPic->getPicSym()->getTileIdxMap(iCUAddr-numCuInWidth) != rpcPic->getPicSym()->getTileIdxMap(iCUAddr))
+        {
+        allowMergeUp = 0;
+        }
+    }
+    pcSbacDecoder->parseSaoOneLcuInterleaving(rx, ry, saoParam,pcCU, cuAddrInSlice, cuAddrUpInSlice, allowMergeLeft, allowMergeUp);
+    }
+#else
     if ( pcSlice->getSPS()->getUseSAO() && pcSlice->getSaoInterleavingFlag() && pcSlice->getSaoEnabledFlag() )
     {
@@ -301,4 +334,5 @@
       pcSbacDecoder->parseSaoOneLcuInterleaving(rx, ry, pcSlice->getAPS()->getSaoParam(),pcCU, cuAddrInSlice, cuAddrUpInSlice, pcSlice->getSPS()->getLFCrossSliceBoundaryFlag() );
     }
+#endif
 
     m_pcCuDecoder->decodeCU     ( pcCU, uiIsLast );
Index: /branches/HTM-6.2-dev0/source/Lib/TLibEncoder/TEncCavlc.cpp
===================================================================
--- /branches/HTM-6.2-dev0/source/Lib/TLibEncoder/TEncCavlc.cpp	(revision 426)
+++ /branches/HTM-6.2-dev0/source/Lib/TLibEncoder/TEncCavlc.cpp	(revision 427)
@@ -720,4 +720,12 @@
 #endif
     }
+
+#if MTK_D0156
+#if MERL_VSP_COMPENSATION_C0152
+    WRITE_FLAG( pcSPS->getUseVSPCompensation() ? 1 : 0,              "view_synthesis_pred_flag" );
+#endif
+
+    WRITE_FLAG( pcSPS->getUseDVPRefine() ? 1 : 0,                    "dv_refine_flag" );
+#endif
   }
   else
@@ -793,4 +801,10 @@
       WRITE_FLAG( pcSlice->getApplyIC() ? 1 : 0, "applying IC flag" );
     }
+#if SHARP_ILLUCOMP_PARSE_D0060
+    if (pcSlice->getApplyIC())
+    {
+      WRITE_FLAG( pcSlice->getIcSkipParseFlag() ? 1 : 0, "ic_skip_mergeidx0" );
+    }
+#endif
   }
 #endif
@@ -960,4 +974,11 @@
       if (pcSlice->getSPS()->getUseSAO())
       {
+#if LGE_SAO_MIGRATION_D0091
+        WRITE_FLAG( pcSlice->getSaoEnabledFlag(), "slice_sao_luma_flag" );
+        {
+            SAOParam *saoParam = pcSlice->getAPS()->getSaoParam();
+            WRITE_FLAG( saoParam->bSaoFlag[1], "slice_sao_chroma_flag" );
+        }
+#else
         WRITE_FLAG( pcSlice->getSaoInterleavingFlag(), "SAO interleaving flag" );
          assert (pcSlice->getSaoEnabledFlag() == pcSlice->getAPS()->getSaoEnabled());
@@ -968,4 +989,5 @@
            WRITE_FLAG( pcSlice->getAPS()->getSaoParam()->bSaoFlag[2], "SAO on/off flag for Cr in slice header" );
          }
+#endif
       }
       WRITE_UVLC( pcSlice->getAPS()->getAPSID(), "aps_id");
@@ -1499,5 +1521,5 @@
   }
 }
-
+#if !LGE_SAO_MIGRATION_D0091
 Void TEncCavlc::codeSaoFlag( UInt uiCode )
 {
@@ -1537,4 +1559,5 @@
   WRITE_CODE( uiCode, uiLength, "sao_run_diff");
 }
+#endif
 
 Void TEncCavlc::estBit( estBitsSbacStruct* pcEstBitsCabac, Int width, Int height, TextType eTType )
Index: /branches/HTM-6.2-dev0/source/Lib/TLibEncoder/TEncCavlc.h
===================================================================
--- /branches/HTM-6.2-dev0/source/Lib/TLibEncoder/TEncCavlc.h	(revision 426)
+++ /branches/HTM-6.2-dev0/source/Lib/TLibEncoder/TEncCavlc.h	(revision 427)
@@ -142,4 +142,11 @@
   Void codeAPSAlflag(UInt uiCode);
   Void codeAlfFixedLengthIdx( UInt idx, UInt numFilterSetsInBuffer);
+#if LGE_SAO_MIGRATION_D0091
+  Void codeSAOSign       ( UInt code   ) { printf("Not supported\n"); assert (0); }
+  Void codeSaoMaxUvlc    ( UInt   code, UInt maxSymbol ){printf("Not supported\n"); assert (0);}
+  Void codeSaoMerge  ( UInt uiCode ){printf("Not supported\n"); assert (0);}
+  Void codeSaoTypeIdx    ( UInt uiCode ){printf("Not supported\n"); assert (0);}
+  Void codeSaoUflc       ( UInt uiLength, UInt   uiCode ){ assert(uiCode < 32); printf("Not supported\n"); assert (0);}
+#else
   Void codeSaoFlag       ( UInt uiCode );
   Void codeSaoUvlc       ( UInt uiCode );
@@ -150,4 +157,5 @@
   Void codeSaoTypeIdx    ( UInt uiCode ){ xWriteUvlc(uiCode   );}
   Void codeSaoUflc       ( UInt uiCode ){ assert(uiCode < 32); xWriteCode(uiCode, 5);}
+#endif
 
   Void codeSkipFlag      ( TComDataCU* pcCU, UInt uiAbsPartIdx );
Index: /branches/HTM-6.2-dev0/source/Lib/TLibEncoder/TEncCfg.h
===================================================================
--- /branches/HTM-6.2-dev0/source/Lib/TLibEncoder/TEncCfg.h	(revision 426)
+++ /branches/HTM-6.2-dev0/source/Lib/TLibEncoder/TEncCfg.h	(revision 427)
@@ -160,5 +160,10 @@
 #endif
   Int       m_maxNumOffsetsPerPic;
+#if LGE_SAO_MIGRATION_D0091
+  Bool      m_saoLcuBoundary;
+  Bool      m_saoLcuBasedOptimization;
+#else
   Bool      m_saoInterleavingFlag;
+#endif
 
   //====== Lossless ========
@@ -339,4 +344,11 @@
   UInt        m_uiMultiviewResPredMode;
 #endif
+#endif
+
+#if MTK_D0156
+#if MERL_VSP_COMPENSATION_C0152
+  Bool      m_bUseVSPCompensation;
+#endif
+  Bool      m_bUseDVPRefine;
 #endif
 
@@ -673,6 +685,13 @@
   Void  setMaxNumOffsetsPerPic                   (Int iVal)            { m_maxNumOffsetsPerPic = iVal; }
   Int   getMaxNumOffsetsPerPic                   ()                    { return m_maxNumOffsetsPerPic; }
+#if LGE_SAO_MIGRATION_D0091
+  Void  setSaoLcuBoundary              (Bool val)      { m_saoLcuBoundary = val; }
+  Bool  getSaoLcuBoundary              ()              { return m_saoLcuBoundary; }
+  Void  setSaoLcuBasedOptimization               (Bool val)            { m_saoLcuBasedOptimization = val; }
+  Bool  getSaoLcuBasedOptimization               ()                    { return m_saoLcuBasedOptimization; }
+#else
   Void  setSaoInterleavingFlag                   (bool bVal)           { m_saoInterleavingFlag = bVal; }
   Bool  getSaoInterleavingFlag                   ()                    { return m_saoInterleavingFlag; }
+#endif
   Void  setTileBehaviorControlPresentFlag        ( Int i )             { m_iTileBehaviorControlPresentFlag = i;    }
   Int   getTileBehaviorControlPresentFlag        ()                    { return m_iTileBehaviorControlPresentFlag; }
@@ -822,4 +841,16 @@
 #endif
 
+#if MTK_D0156
+
+#if MERL_VSP_COMPENSATION_C0152
+  Bool    getUseVSPCompensation( ){  return m_bUseVSPCompensation;}
+  Void    setUseVSPCompensation( Bool bValue ){ m_bUseVSPCompensation = bValue;}
+#endif
+
+
+  Bool    getUseDVPRefine( ){  return m_bUseDVPRefine;}
+  Void    setUseDVPRefine( Bool bValue ){ m_bUseDVPRefine = bValue;}
+#endif
+
 };
 
